% ========================================================
% Duffing_EnergyPlot_2.m
%
% CBP 21-01-21
%
% F = -x + epx*x^3
% H = (1/2)x^2 - (eps/4)x^4 + (1/2)v^2
%
% =========================================================

x = -4:0.1:4;
y = -4:0.1:4;
alpha = 1;
gamma = 0.25;
beta = input('Input beta ');
x0 = input('Input start x (start v = 0) ');
[xx,yy] = meshgrid(x,y);
% zz = 0.5*yy.^2 + 0.5*alpha*xx.^2 + 0.25*gamma*xx.^4;
zz = (-beta/2)*xx.^2 + 0.25*xx.^4 + 0.5*yy.^2;
figure(1);
colormap(jet());
% mesh(xx,yy,zz);
surf(xx,yy,zz);
xlabel('x');
ylabel('v');
zlabel('V');



sp2 = figure(2);
hold off; clf;

contour(xx,yy,zz,20);

axis([-4,4,-4,4]);
hold on;

maxT = 20;
dT = 0.1;
time = [0:dT:maxT];
eps = gamma;
x = x0;
v = 0;

i = 1;
while i < length(time) - 1

  xPrev = x;
  yPrev = y;
  F = beta*x - x^3;
  a = F;
  v = v + a*dT;
  x = x + v*dT;
  y = v;
  plot(x,v,'r.','MarkerSize',8);
  z = 0.5*x.^2 - 0.25*gamma*x.^4 + 0.5*v.^2;  
  %plot(sp1,yPrev,xPrev,'w.','MarkerSize',20);    
  %plot(sp1,yPrev,xPrev,'g.','MarkerSize',15); 

  drawnow;
  i++;
endwhile
