% ============================================================
%
% Oscillator_Phase_Plane.m
%
% CBP 12-20-21 Demo's phase plane and trace for linear oscill
% pkg load matgeom
%
% ============================================================
clf; hold on;
axis([-10,10,-10,10]);
axis('square');

dT = 0.1;
T1 = 0;
T2 = 50;
period = 5;
b = 0.0;
om = 2*pi/period;
A = 2;
AA = 1.5*A;
time = [0:dT:10];


l1 = line(0,0,'color','r','linewidth',3);

sp1 = subplot(1,2,1);
sp2 = subplot(1,2,2);
drawCircle(sp1,[0,0,A]);
title(sp1,'Phase Plane');
ylabel(sp1,'displacement');
xlabel(sp1,'velocity');

title(sp2,'Displacement - time Plot');
xlabel(sp2,'time');
ylabel(sp2,'displacement');


hold(sp1);
hold(sp2);
  
x = 0;
y = 0;

i = 1;
while i < length(time) - 1

  drawCircle(sp1,[0,0,A],'g');

  xPrev = x;
  yPrev = y;
  theta = om*time(i);
  x = A*exp(b*time(i))*cos(theta);
  y = A*exp(b*time(i))*sin(theta);
  plot(sp1,x,y,'r.','MarkerSize',20);
  plot(sp1,xPrev,yPrev,'w.','MarkerSize',20);    
  axis([-AA,AA,-AA,AA]);
  
  plot(sp2,time(i),y,'o');
  axis([0,max(time),-AA,AA]);  
  drawnow;
  i++;
endwhile
