% ============================================================
%
% Oscillator_Phase_Plane2.m
%
% CBP 12-20-21 Demo's phase plane and trace for F = -x + eps*x^3
% Useful for live mini-lecture demo.
% pkg load matgeom
%
% ============================================================
clf; hold on;
axis([-10,10,-10,10]);
axis('square');

dT = 0.1;
%T1 = 0;
%T2 = 50;
%period = 2;
%om = 2*pi/period;
eps = input('Input eps ') %=0.2;
A = input('Input init x ')%=2;
AA = 1.5*A;
maxT = 20;
time = [0:dT:maxT];

sp1 = subplot(1,2,1);
sp2 = subplot(1,2,2);
drawCircle(sp1,[0,0,A],'c');
title(sp1,'Phase Plane');
ylabel(sp1,'displacement');
xlabel(sp1,'velocity');

title(sp2,'Displacement - time Plot');
xlabel(sp2,'time');
ylabel(sp2,'displacement	');

hold(sp1);
hold(sp2);
  
x = A;
y = 0;
v = 0;

i = 1;
while i < length(time) - 1

  drawCircle(sp1,[0,0,A],'c');

  xPrev = x;
  yPrev = y;
  %theta = om*time(i);
  F = -x + eps*x^3;
  a = F;
  v = v + a*dT;
  x = x + v*dT;
  y = v;
  plot(sp1,y,x,'r.','MarkerSize',20);
  plot(sp1,yPrev,xPrev,'w.','MarkerSize',20);    
  plot(sp1,yPrev,xPrev,'g.','MarkerSize',15); 
  axis([-AA,AA,-AA,AA]);
  
  plot(sp2,time(i),x,'o');
  axis([0,max(time),-AA,AA]);  
  drawnow;
  i++;
endwhile
