% ============================================================
%
% Oscillator_Phase_Plane2.m
%
% CBP 12-20-21 Demo's phase plane and trace for F = -x + eps*x^3
% Useful for live mini-lecture demo.
% pkg load matgeom
%
% ============================================================
clf; hold on;

t=0.0:0.01:4.0;
f0 = 1.0;
a2 = input('Input amp of 2nd harmonic ');
y1 = cos(2*pi*f0*t);
y2 = a2*cos(2*pi*2*f0*t);
v = -(2*pi*f0)*sin(2*pi*f0*t) - a2*(2*pi*2*f0)*sin(2*pi*2*f0*t);

figure(1);
subplot(3,1,1)
plot(t,y1);
subplot(3,1,2)
plot(t,y2);
subplot(3,1,3)
plot(t,y1+y2);
figure(2);
plot(y1+y2,v);

%{
i = 1;
while i < length(time) - 1

  drawCircle(sp1,[0,0,A],'c');

  xPrev = x;
  yPrev = y;
  %theta = om*time(i);
  F = -x + eps*x^3;
  a = F;
  v = v + a*dT;
  x = x + v*dT;
  y = v;
  plot(sp1,y,x,'r.','MarkerSize',20);
  plot(sp1,yPrev,xPrev,'w.','MarkerSize',20);    
  plot(sp1,yPrev,xPrev,'g.','MarkerSize',15); 
  axis([-AA,AA,-AA,AA]);
  
  plot(sp2,time(i),x,'o');
  axis([0,max(time),-AA,AA]);  
  drawnow;
  i++;
endwhile
%}
