% =============================================================================
%
% solve_NL_DDHO

%
% =============================================================================

global alpha beta gamma omega0squ omegaDrive

tstart = 0;
tend = input('Input end time');


% parameters ------------------------------------
omegaDrive = 2*pi
omega0 = 1.5*omegaDrive
omega0squ = omega0^2
beta = omega0/4.0
alpha = 1.0
phi0 = -pi/2;

gamma = input('Input gamma ');

xinit = [phi0,0];

options = odeset('RelTol',1e-6,'AbsTol',1e-6,'InitialStep',tend/1e4,'MaxStep',tend/1e4);

[t,y] = ode45(@rhs_NL_DDHO,[tstart,tend],xinit,options);


figure(1);
plot(y(:,1),y(:,2),'-');
hold on
% plot(cos(omegaDrive*t),-sin(omegaDrive*t),'.');
axis('square');
xlabel('displacement');
ylabel('velocity');
str = sprintf("Phase plane for gamma = %f\n",gamma);
title(str);
hold off;

figure(2);
plot(t,y(:,1));
hold on;

plot(t,cos(omegaDrive*t),'-');
xlabel('time');
ylabel('displacement');
str = sprintf("x-t plot for gamma = %f\n",gamma);
title(str);
hold off;

%printf("Period of linear system = %f\n",2*pi);
%printf("Period of non-linear system (approx) = %f\n",2*pi/omega);


T = t(length(t))
N = length(y(:,2));

yy = fft(y(:,2));

f=[0:1/(T):(N-1)/(T)]';

figure(3);
plot(f,abs(yy));
axis([0,10,0,0.8*max(yy)]);
xlabel('frequency (cycles per second)');
ylabel('power');
str = sprintf("spectral plot for gamma = %f\n",gamma);
title(str);

